<template>
  <div class="row justify-center">
    <q-card style="width: 500px; max-width: 300px">
      <q-img v-if="midtrans.va_numbers[0].bank == 'bni'" src="~assets/bni.png"/>
      <q-img v-if="midtrans.va_numbers[0].bank == 'bca'" src="~assets/bca.png"/>
      <q-img v-if="midtrans.va_numbers[0].bank == 'bri'" src="~assets/bri.png"/>
      <q-card-section>
        <q-item-label class="text-center">
          Silahkan Lakukan Pembayaran Melalui Rekening Virtual Account dibawah ini :
        </q-item-label>
      </q-card-section>
      <q-card-section>
        <q-item-label class="text-center" >
          Transaction ID : {{ midtrans.order_id }}
        </q-item-label>
      </q-card-section>
      <q-card-section>
        <q-item-label class="text-h5 text-center" @click="copyVa" style="cursor:pointer;">
          {{ midtrans.va_numbers[0].va_number }}
        </q-item-label>
        <q-item-label class="text-center" @click="copyVa" style="cursor:pointer;" caption>
          Click to Copy
        </q-item-label>
      </q-card-section>
      <q-card-section>
        <q-item-label class="text-h5 text-center" @click="copyJumlah" style="cursor:pointer;">
          {{ formatRupiah(midtrans.gross_amount.slice(0, -2), "Rp.") }}
        </q-item-label>
        <q-item-label class="text-center" @click="copyJumlah" style="cursor:pointer;" caption>
          Clik to Copy
        </q-item-label>
      </q-card-section>
      <q-separator />
      <q-card-section>
        <p>Mohon Untuk tidak mengorder ulang pesanan, karena nomor virtual account akan berubah, sebelum transfer pastikan nomor virtual account yang tertera dan jumlah yang dibayarkan sama</p>
        <q-separator style="margin-bottom: 10px" />
        <p>Jika ada kendala, Silahkan Hubungi Admin melalui fitur chatting, Terima Kasih</p>
      </q-card-section>
      <q-card-actions>
        <q-btn @click="cekPayment" label="Saya Sudah Melakukan Pembayaran" color="green" />
      </q-card-actions>
    </q-card>
  </div>
</template>

<script>
import { copyToClipboard } from 'quasar'

export default {
  name: 'BankTransfer',
  data () {
    return {
      midtrans: this.$attrs.midtrans
    }
  },
  methods: {
    cekPayment() {
      this.$q.loading.show()
      this.$axios.get("api/order/level/" + this.midtrans.order_id )
      .then(sukses => {
        let data = sukses.data
        if (data.message == "yes") {
          this.$q.notify({
            message: "Pembayaran Berhasil, Akun Level anda telah di upgrade, anda akan dirahkan ke halaman profile untuk memastikan Level Anda sudah berubah",
            position: "top",
            color: "green"
          })
          this.$emit("gagalPencegahan")
          this.$router.push("/profile")
        } else {
          this.$q.notify({
            message: "Maaf Pembayaran Belum diterima",
            position: "top",
            color: "orange"
          })
          this.$emit("tutupPencegahan")
        }
        this.$q.loading.hide()
      })
      .catch(eror => {
        this.$q.loading.hide()
      })
    },
    copyVa() {
      copyToClipboard(this.midtrans.va_numbers[0].va_number)
      .then(sukses => {
        this.$q.notify({
          message: "Berhasil Copy Virtual Number ke Clipboard",
          color: "green",
          position: "top"
        })
      })
    },
    copyJumlah() {
      copyToClipboard(this.midtrans.gross_amount.slice(0, -3))
      .then(sukses => {
        this.$q.notify({
          message: "Berhasil Copy Virtual Number ke Clipboard",
          color: "green",
          position: "top"
        })
      })
    },
    formatRupiah(angka, prefix){
      var number_string = angka.replace(/[^,\d]/g, '').toString(),
        split   		= number_string.split(','),
        sisa     		= split[0].length % 3,
        rupiah     		= split[0].substr(0, sisa),
        ribuan     		= split[0].substr(sisa).match(/\d{3}/gi);
      // tambahkan titik jika yang di input sudah menjadi angka ribuan
      if(ribuan){
        let separator = sisa ? '.' : '';
        rupiah += separator + ribuan.join('.');
      }
      rupiah = split[1] != undefined ? rupiah + ',' + split[1] : rupiah;
      return prefix == undefined ? rupiah : (rupiah ? 'Rp. ' + rupiah : '');
    },
  }
}
</script>
